//! Base class, very generic.
class A
{
public:
    
    //! Use when you want to do something.
    virtual void DoSomething () {
    
        for (int i (0); i < 3; i++) {
        
            // do something interesting
        }
    };

    //! Use when you want to do something, but differently.
    virtual void DoSomethingDifferently ()
    {
        for (int j (3); i < 6; j++) {
        
            // do something interesting but differently
        }
    };
    
    //! Use when you want to do something, but differently.
    void DoSomethingDifferentlyAgain ()
    {
        for (int j (3); i < 6; j++) {
        
            // do something interesting but differently
        }
    };
};

//! Derived class, more specific.
class B : public A
{
public:
    
    //! Use when you want to do something.
    virtual void DoSomething () {

        for (int k (6); k < 9; k++) {
        
            // do something interesting
        }
    };
};